<template>
  <base-dialog :show="!!error" title="An error occurred!">
    <p>{{ error }}</p>
  </base-dialog>
  <form @submit.prevent="submitForm" :class="{errors: !formIsValid}">
    <div class="form-control" >
      <label for="email">Email</label>
      <input type="email" id="email" v-model.trim="email" >

    </div>
    <div class="form-control" :class="{errors: !formIsValid}">
      <label for="message">Message</label>
      <textarea id="message" rows="5" v-model.trim="message"></textarea>

    </div>
    <p v-if="!formIsValid">Message and Email must not be empty!</p>
    <div class='actions'>
      <base-button>Send message</base-button>
    </div>

  </form>
</template>

<script>
export default {
  name: 'ContactCoach',
  data(){
    return {
      error: null,
      message:'',
      email:'',
      formIsValid: true
    };
  },
  methods: {
    submitForm(){
      if(this.email === '' || !this.email.includes('@') || this.message === ''){
        this.formIsValid = false;
        return;
      }
      this.formIsValid = true;
      try{
        this.$store.dispatch('req/addRequest',{
        email: this.email,
        message: this.message,
        coachId: this.$route.params.id
      });
      }catch(error){

        this.error = error.message || 'Something went wrong!'
      }
      this.$router.replace('/coaches')
    }
  }

};
</script>

<style scoped>
form {
  margin: 1rem;
  border: 1px solid #ccc;
  border-radius: 12px;
  padding: 1rem;
}

.form-control {
  margin: 0.5rem 0;
}

label {
  font-weight: bold;
  margin-bottom: 0.5rem;
  display: block;
}

input,
textarea {
  display: block;
  width: 100%;
  font: inherit;
  border: 1px solid #ccc;
  padding: 0.15rem;
}

input:focus,
textarea:focus {
  border-color: #3d008d;
  background-color: #faf6ff;
  outline: none;
}

.errors {
  font-weight: bold;
  color: red;
}

.actions {
  text-align: center;
}
</style>